{
$Id: fgldebug.4gl,v 1.1.1.1 1998/07/21 10:27:53 rene Exp $
}
use fdb
globals define
  fdb_line smallint,
  fdb_run_status smallint,
  fdb_status smallint
end globals

define 
  module record
    name char(80),
    first integer,
    src array[25] of record 
      line int,
      break char(1),
      buff char(70)
    end record
  end record,
  dataC integer,
    path  char(40),
  data array[100] of record
    path  char(40),
    value char(40)
  end record,
  f array[100] of record
    name char(20),
    module char(20),
    line int 
  end record,
  breakPoint array[100] of record 
    function char(20),
    src char(20),
    line int
  end record

function fdb_source(name,line)
  define 
    i,line integer,
    m,name char(80)
  if line < 1 or line is null then return end if
  if name==module.name then 
    case 
    when line<module.first    let module.first=line
    when line>module.first+5 let module.first=line-5
    end case
  else
    let module.name=name
    let module.first=line-5
    if module.first<1 then let module.first=1 end if
  end if
  let m=fdb::src_first(module.name,module.first)
  let i=0
  while i<10 and m is not null
    let i=i+1
    let module.src[i].buff =m
    let module.src[i].break=fdb::src_isbreak()
    let module.src[i].line =module.first+i-1
    let m=fdb::src_next()
  end while
  call set_count(i)
  input array module.src without defaults from src.* 
  before input exit input
  end input
  let i=line-module.first+1
  display module.src[i].* to src[i].* attribute(reverse)
  display name to scope
  --message m
end function

function fdb_srcView(name)
  define 
    name char(80),
    i,s,again integer,
    src array[1000] of record 
      line int,
      break char(1),
      buff char(70)
    end record,
    m char(80)
  let again=1
  while again
    let again=0
    let i=0
    let m=fdb::src_first(name,1)
    while i<1000 and m is not null
      let i=i+1
      let src[i].buff=m
      let src[i].break=fdb::src_isbreak()
      let src[i].line=i
      let m=fdb::src_next()
    end while
    let m= "(",name,")"
    --message m
    display m to scope
    call set_count(i)
    display array src to src.* 
    on key(f7)
      let again=1
      let name=fdb_moduleSel()
      exit display
    on key(return)
      let s=scr_line()
      let i=arr_curr()
      if fdb::break_at(name,i)==1 then
        let src[i].break="B"
      else
        let src[i].break=""
      end if
      display src[i].break to src[s].break
    end display
  end while
end function

function fdb_dataDebug()
  define 
    i integer
  for i=1 to dataC
    call fdb::data_debug(data[i].path)
  end for
end function

function fdb_dataAdd()
  define 
    i,s integer,
    path char(40)
  for i=1 to dataC
    let data[i].value=fdb::data_value(data[i].path)
  end for
  call set_count(dataC)
  input array data without defaults from watch.* 
  before row
    let s=scr_line()
    let i=arr_curr()
  on key(f6)
    call fdb::data_debug(data[i].path)
  on key(f5)
    let path=fdb_dataTree(1,"R")
    if path is not null then 
      let data[i].path =path
      let data[i].value=fdb::data_value(data[i].path)
      display data[i].* to watch[s].*
    end if
  after field path
    let data[i].value=fdb::data_value(data[i].path)
    display data[i].* to watch[s].*
  end input
  let dataC=arr_count()
end function

function fdb_dataWatch()
  define 
    i integer
  for i=1 to dataC
    let data[i].value=fdb::data_value(data[i].path)
  end for
  call set_count(dataC)
  input array data without defaults from watch.* 
  before input
    exit input 
  end input
end function

function fdb_dataTree(l,dir)
  define
    m char(256),
    i,j,s,l integer,
    dir char(1),
    d array[500] of record 
      name char(20),
      type char(25),
      size smallint,
      member smallint,
      value char(20)
    end record,
    n char(20), 
    path,rv,p char(70)
  let int_flag=0
  let i=0
  if l=1 then open window fdb_data at 1,1 with form "fdb_data" attribute(form line 2,message line first) end if
  let path=fdb::symb_name()
  display by name path 
  let n=fdb::symb_first(dir)
  while n is not null and i<500
      let i=i+1
      let d[i].name=n
      let d[i].type=fdb::symb_type()
      let d[i].size=fdb::symb_size()
      let d[i].member=fdb::symb_isroot()
      let d[i].value=fdb::symb_value()
      let n=fdb::symb_next()
  end while
  call set_count(i)
  let rv=""
  display array d to data.* 
  on key(return) 
    let i=arr_curr()
    if length(path) then
      let rv=path clipped,".",d[i].name 
    else 
      let rv=d[i].name 
    end if
    exit display
  on key(right)
    call fdb::symb_seek(arr_curr())
    if fdb::symb_isroot() then
      let i=arr_curr()
      let s=scr_line()
      let rv=fdb_dataTree(l+1,"C")
      let n=fdb::symb_first("P")
      if rv is not null then exit display end if
      for j=1 to 20 display d[j+i-s].* to data[j].* end for
    end if
  on key(left)
    exit display
  on key(f6)
    let i=arr_curr()
    let i=arr_curr()
    if length(path) then
      let p=path clipped,".",d[i].name 
    else 
      let p=d[i].name 
    end if
    call fdb::data_debug(p)
  end display
  if l==1 then close window fdb_data end if
  return rv
end function

function fdb_functionSel(dialog)
  define 
    i,int,dialog integer,
    n char(20)
  let i=0
  let n=fdb::function_first()
  while n is not null and i<100
    let i=i+1
    let f[i].name=n
    let f[i].module=fdb::function_module()
    let f[i].line=fdb::function_line()
    let n=fdb::function_next()
  end while
  call set_count(i)
  if dialog then 
    let int_flag=0
    display array f to function.* end display
    if int_flag then return "" end if
    --let i=arr_curr()
    --return f[i].name
    return arr_curr()
  else
    input array f without defaults from function.* before input exit input end input
  end if
  return ""
end function

function fdb_moduleSel()
  define 
    i integer,
    m array[100] of char(20),
    n char(20)
  let i=0
  open window fdb_module at 6,2
    with form "fdb_mod" 
    attribute(form line first,border)
  let n=fdb::module_first()
  while n is not null and i<100
    let i=i+1
    let m[i]=n
    let n=fdb::module_next()
  end while
  call set_count(i)
  let int_flag = 0
  display array m to m.* 
  let i=arr_curr()
  close window fdb_module
  if int_flag then return "" end if
  let i=arr_curr()
  return m[i]
end function

function fdb_breakView()
  define 
    i,s,x,doit integer,
    name,name0 char(20)
  let i=0
  open window fdb_break at 1,1 with form "fdb_break" attribute(form line 3,message line last)
  let doit=1
while doit
  let doit=0
  let x=fdb::break_first()
  while x and i<100
    let i=i+1
    let breakPoint[i].src=fdb::break_src()
    let breakPoint[i].line=fdb::break_line()
    let breakPoint[i].function=fdb::break_function()
    let x=fdb::break_next()
  end while
  if not i then 
    error "No breakpoints."
  end if
--  let i=fdb_functionSel(0)
  call set_count(i)
  input array breakPoint without defaults from break.* 
  on key(f6)
    let doit=1;exit input
  before row 
    let i=arr_curr()
    let s=scr_line()
    call fdb_source(breakPoint[i].src,breakPoint[i].line)
  after field function
    if not field_touched(function) then continue input end if
    let x=fdb::break_in(breakPoint[i].function)
    if(x<0) then
      error "Error:Breakpoint not set"
      let x=fdb_functionSel(1)
      if x>=1 then
        let breakPoint[i].*=f[x].*
        display breakPoint[i].* to break[s].*
        let x=fdb::break_in(breakPoint[i].function)
        --display f[x].* to break[s].*
      end if
    end if
  after field src
    if field_touched(src) then
      if not fdb::module_exist(breakPoint[i].src) then
        let breakPoint[i].src=fdb_moduleSel()
        display breakPoint[i].src to break[s].src
      end if
    end if
  after field line
    if not field_touched(line) then continue input end if
    let x=fdb::break_at(breakPoint[i].src,breakPoint[i].line)
    if(x<0) then
      error "Error:Breakpoint not set"
      next field src
    end if
  after delete
    let x=fdb::break_at(breakPoint[i].src,breakPoint[i].line)
    if(x<0) then 
      error "Error:Breakpoint not deleted"
    end if
  end input
  if doit and i>0 then call fdb_srcView(breakPoint[i].src) end if
end while
  close window fdb_break 
end function

function fdb_statusLine()
  define m varchar(80)
  case fdb_run_status 
    when 1 let m= "Break"
    when 2 let m= "Finish"
    when 3 
      let m=err_get(fdb_status)
      error m
      let m="Stopp"
    otherwise let m=""
  end case
  let m=m," ",fdb::file()," in :",fdb::function(),"(",fdb_line using "<<<<",")"
  display m to scope
end function

function fdb_main()
  define 
    i,j integer,
    line integer,
    module char(20),
    command char(80)
  open window fdb_source at 1,1
    with form "fdb_src" 
    attribute(form line 3,message line last{,border})
  call fdb_source(fdb::file(),fdb_line)
  call fdb_statusLine()
  call fdb_dataWatch()
  menu "FDB"
  before menu
    --if fdb_run_status!=1 then  
    --  hide option "Next","Step","Continue"
    --else 
    --  hide option "Run"
    --end if
  --command "Run" "Run the program"
  --  call fdb::run()
  --  exit menu
  command "Next" "Execute the next statement"
    call fdb::next()
    exit menu
  command "Step" "Step into function or Execute the next statement"
    call fdb::step()
    exit menu
  command "Continue" "Execute until next breakpoint"
    call fdb::continue()
    exit menu
  command "Breakpoints" "List and set breakpoints"
    call fdb_breakView()
  command "Data" "Inspect values and types of variables."
    menu "DATA"
    command "Debug"     call fdb_dataDebug() next option "End"
    command "Add watch" call fdb_dataAdd()   next option "End"
    command "Tree"      let path=fdb_dataTree(1,"R")
      if path is not null then 
        let dataC=dataC+1
        let data[dataC].path =path
        call fdb_dataWatch()
      end if
    command "End" exit menu
    end menu
  command "Module" "View 4gl source file, set breakpoint"
    call fdb_srcView(fdb::file())
  command key("h") "sHell" "Call Shell"
    prompt "COMMAND:" for command
    run command
  command "Quit" "Exit program and debugger"
    exit program
  end menu
  close window fdb_source
end function
