###############################################################################
## Compagny     : 4JS
## Program      : fglreportp.4gl
## Date         : 12/06/1996
## Version      : 1.00
##
## Titel        : Managment of report:  10 Previous/Next Page data stores 
##                                      if database is not available
###############################################################################

###############################################################################
##			     	VARIABLES
###############################################################################
  DEFINE vrep ARRAY[10] OF RECORD     # FIFO storage data
             lg     INTEGER,
             page   ARRAY[100] OF CHAR(256),
             ind    INTEGER
         END RECORD,
         withdb SMALLINT, # TRUE if we can use temp tables
         indb   SMALLINT, # TRUE if we can use database
         idxpg  INTEGER,  # Index of first in FIFO
         fpg    INTEGER,  # First page number
         lpg    INTEGER   # Last page number
 
DEFINE curr_page    INTEGER,
       continue_rep SMALLINT,
       display_rep  SMALLINT,
       openwin      SMALLINT

FUNCTION fgl_report_start(pagelength,topmargin,bottommargin,
                          leftmargin,rightmargin) 
  DEFINE pagelength,topmargin,bottommargin,leftmargin,rightmargin INTEGER

  OPEN WINDOW fglreport AT 1,0 WITH 24 ROWS, 80 COLUMNS
    ATTRIBUTE(FORM LINE FIRST)

  OPEN FORM fglreport FROM "fglreport"

  DISPLAY FORM fglreport

  LET openwin      = 1
  LET curr_page    = 0
  LET continue_rep = FALSE
  LET display_rep  = TRUE
  LET idxpg        = 0
  IF withdb THEN
    CALL fgl_report_use_temptable()
  END IF

END FUNCTION

FUNCTION fgl_report_show_page(n,p)
  DEFINE 
    i INTEGER,
    n INTEGER,
    dsppage SMALLINT,
    p ARRAY[100] OF VARCHAR(256),
    oldint  SMALLINT

  IF NOT display_rep THEN
    RETURN
  END IF

  LET oldint = int_flag
  LET curr_page = curr_page + 1

  CURRENT WINDOW IS fglreport

  IF curr_page > fgl_report_maxpage() THEN
    CALL fgl_report_storelength(curr_page,n)
    FOR i = 1 TO n
       IF n > 100 THEN
         EXIT FOR
       END IF
       CALL fgl_report_storeline(curr_page,i,p[i])
    END FOR
  END IF

  IF n < 1 THEN RETURN END IF

  let dsppage=1
  WHILE dsppage 
    LET dsppage = 0
    CALL set_count(n)

    DISPLAY ARRAY p TO LINES.* 

      ON KEY(ACCEPT,ESCAPE,f6)
        LET i = curr_page + 1
        IF i > fgl_report_maxpage() THEN
          IF continue_rep THEN
            LET dsppage = 2
            ERROR "This is the last visible page"
          ELSE
            LET dsppage = 0
          END IF
        ELSE
          LET curr_page = i
          LET dsppage = 1
        END IF
        EXIT DISPLAY

      ON KEY(f5)
        LET i = curr_page - 1
        IF i < fgl_report_minpage() THEN
          ERROR "This is the first visible page"
          LET dsppage = 2
        ELSE
          LET curr_page = i
          LET dsppage = 1
        END IF
        EXIT DISPLAY
    END DISPLAY
 
    IF dsppage = 1 THEN
      LET n = fgl_report_givelength(curr_page)
      FOR i = 1 TO n
        LET p[i] = fgl_report_giveline(curr_page,i)
      END FOR
    END IF
  END WHILE

  IF int_flag AND NOT oldint THEN
    LET display_rep = FALSE
  END IF

END FUNCTION

FUNCTION fgl_report_continue(val) 

  DEFINE val SMALLINT

  LET continue_rep = val

END FUNCTION

FUNCTION fgl_report_finish() 

  DEFINE 
    i INTEGER,
    rp RECORD
      n         INTEGER,
      p ARRAY[100] OF VARCHAR(256)
    END RECORD

  LET curr_page = fgl_report_maxpage()
  IF continue_rep AND NOT int_flag AND curr_page != 0 THEN
    LET rp.n      = fgl_report_givelength(curr_page)
    FOR i = 1 TO rp.n
      LET rp.p[i] = fgl_report_giveline(curr_page,i)
    END FOR
    LET curr_page = curr_page - 1
    CALL fgl_report_show_page(rp.*)
  END IF
    

  IF openwin THEN
    CLOSE WINDOW fglreport
  END IF
  LET openwin=0

  CALL fgl_report_freedata()

END FUNCTION

###############################################################################
##			     	FUNCTIONS
###############################################################################

################################################################################
## FUNCTION fgl_report_use_temptable : Create table for report
## Parameters :
##          curr_page : Current page
## Returnings :
##  ind : Index in array
################################################################################

FUNCTION fgl_report_use_temptable()

# first usage in this report
   WHENEVER ERROR CONTINUE
   DROP TABLE hpage
   DROP TABLE vpage
   CREATE TEMP TABLE hpage (nopage INTEGER, len INTEGER)
   CREATE TEMP TABLE vpage (nopage INTEGER, noline INTEGER, val VARCHAR(255,80))
   CREATE TEMP TABLE vpage (nopage INTEGER, noline INTEGER, val CHAR(256))
   CREATE INDEX ix_hpage ON hpage(nopage)
   CREATE INDEX ix_vpage ON vpage(nopage,noline)
   LET indb        =  (status >= 0)
   WHENEVER ERROR STOP
   IF indb THEN
     LET fpg=1
     LET lpg=0
     LET withdb = TRUE
   END IF

END FUNCTION

################################################################################
## FUNCTION vreport_page : Give index of current and manage data of storing
## Parameters :
##          curr_page : Current page
## Returnings :
##  ind : Index in array
################################################################################

FUNCTION vreport_page(curr_page)

     DEFINE curr_page INTEGER,
            i         INTEGER,
            idx       INTEGER

 IF indb THEN
   IF idxpg = curr_page THEN
     RETURN 1
   END IF
   LET idxpg = curr_page
   SELECT len
      INTO vrep[1].lg
     FROM hpage
       WHERE nopage = curr_page
   IF status = NOTFOUND THEN
     ERROR "Bad current page in report"
     sleep 2
     RETURN -1
   END IF
   let  i = vrep[1].lg
   FOR i = 1 TO vrep[1].lg
     SELECT val
        INTO vrep[1].page[i]
       FROM vpage
         WHERE nopage = curr_page
           AND noline = i
     IF status = NOTFOUND THEN
       ERROR "Bad current line in report"
       RETURN -1
     END IF
   END FOR
   RETURN 1
 ELSE
   IF idxpg = 0 THEN
     LET fpg=curr_page
     LET lpg=curr_page
     LET idxpg=1
     RETURN idxpg
   END IF
   CASE
     WHEN curr_page = lpg + 1
       LET lpg = lpg + 1
       IF lpg - fpg >= 10 THEN
         LET fpg = fpg + 1
         LET idxpg = idxpg + 1
         IF idxpg > 10 THEN
           LET idxpg = 1
         END IF
       END IF
     WHEN curr_page = fpg - 1
       LET fpg = fpg - 1
       IF lpg - fpg >= 10 THEN
         LET lpg = lpg - 1
         LET idxpg = idxpg - 1
         IF idxpg = 0 THEN
           LET idxpg = 10
         END IF
       END IF
     WHEN curr_page <= lpg AND curr_page >= fpg
       EXIT CASE
     OTHERWISE
       ERROR "Bad current page in report"
       RETURN -1
   END CASE

   LET idx = ( curr_page - fpg + idxpg ) MOD 10

   IF NOT idx THEN
     RETURN 10
   END IF
 END IF

 RETURN idx

END FUNCTION

################################################################################
## FUNCTION exist_page : Verify if a page exist and update and create it
## Parameters :
##          curr_page : Current page
##          lg        : Length of page
## Returnings :
##  none
################################################################################

FUNCTION exist_page(curr_page,lg)

       DEFINE curr_page, lg INTEGER

  SELECT *
    FROM hpage
      WHERE nopage = curr_page

  IF status = NOTFOUND THEN
    INSERT INTO hpage VALUES(curr_page,lg)
  ELSE
    IF lg THEN
      UPDATE hpage SET len = lg
        WHERE nopage = curr_page
    END IF
  END IF

END FUNCTION

################################################################################
## FUNCTION fgl_report_storelength : Store length of currpage
## Parameters :
##          curr_page : Current page
##          lg        : Length of page
## Returnings :
##  none
################################################################################

FUNCTION fgl_report_storelength(curr_page,lg)

       DEFINE curr_page, lg,ind INTEGER


 IF indb THEN
   IF curr_page > lpg THEN
     LET lpg = curr_page 
   END IF
   CALL exist_page(curr_page,lg)
 ELSE
   LET ind = vreport_page(curr_page)
   IF ind = -1 THEN
     RETURN
   END IF
   LET vrep[ind].lg = lg
 END IF

END FUNCTION

################################################################################
## FUNCTION fgl_report_storeline : Store length of currpage
## Parameters :
##                  curr_page : Current page
##                  ind       : Current index
##                  line      : Current line
## Returnings :
##  none
################################################################################


FUNCTION fgl_report_storeline(curr_page,idx,line)

       DEFINE curr_page,idx,ind INTEGER,
              line              CHAR(256)

 IF indb THEN
   WHENEVER ERROR CONTINUE
   INSERT INTO vpage VALUES(curr_page,idx,line)
   WHENEVER ERROR STOP
 ELSE
   LET ind = vreport_page(curr_page)
   IF ind = -1 THEN
     RETURN
   END IF
   LET vrep[ind].page[idx] = line
 END IF

END FUNCTION

################################################################################
## FUNCTION fgl_report_maxpage : Give index of greater stored page
## Parameters :
##                  none
## Returnings :
##  idx
################################################################################

FUNCTION fgl_report_maxpage()

RETURN lpg

END FUNCTION

################################################################################
## FUNCTION fgl_report_minpage : Give index of least stored page
## Parameters :
##                  none
## Returnings :
##  idx
################################################################################

FUNCTION fgl_report_minpage()

RETURN fpg

END FUNCTION

################################################################################
## FUNCTION fgl_report_givelength : Give length of currpage
## Parameters :
##                  curr_page : Current page
## Returnings :
##  lg:           length of page
################################################################################

FUNCTION fgl_report_givelength(curr_page)

       DEFINE curr_page,ind     INTEGER

 LET ind = vreport_page(curr_page)
 IF ind = -1 THEN
   RETURN -1
 END IF

 RETURN vrep[ind].lg

END FUNCTION

################################################################################
## FUNCTION fgl_report_giveline : Give line of currpage
## Parameters :
##                  curr_page : Current page
##                  index     : Index in page
## Returnings :
##  nbret : Number of returning: 1
################################################################################

FUNCTION fgl_report_giveline(curr_page,idx)
       DEFINE curr_page,ind,idx   INTEGER

 LET ind = vreport_page(curr_page)
 IF ind = -1 THEN
   RETURN ""
 END IF

 RETURN vrep[ind].page[idx]

END FUNCTION

################################################################################
## FUNCTION fgl_report_freedata : Free data of current report
## Parameters :
##                  none
## Returnings :
##  nbret : Number of returning: 1
################################################################################

FUNCTION fgl_report_freedata()

  LET idxpg = 0

  IF indb THEN
   WHENEVER ERROR CONTINUE
   DROP TABLE hpage
   DROP TABLE vpage
   WHENEVER ERROR STOP
  END IF

END FUNCTION
